# setwd("C:/Users/nwickelmaier/Nextcloud/Documents/MDS/2023ss/60100_master_thesis/code")

#library(mtt)
devtools::load_all("../../../../software/mtt")

now <- format(Sys.time(), "%Y-%m-%d_%H-%M-%S")
#now <- "2023-09-23_01-31-30"

path <- "../data/haum/LogFiles/"

folders <- dir(path)

# parse raw log files
#datraw <- parse_logfiles(folders, path)
datraw <- read.table("../data/haum/raw_logfiles_small_2023-09-26_13-50-20.csv",
                     sep = ";", header = TRUE)

# export data
write.table(datraw, paste0("../data/haum/raw_logfiles_", now, ".csv"),
            sep = ";", row.names = FALSE)

# convert to log events
datlogs <- create_eventlogs(datraw, 
           xmlpath = "../data/haum/ContentEyevisit/eyevisit_cards_light/")

artworks <- unique(na.omit(datlogs$artwork))
artworks <- artworks[!artworks %in% c("504", "505")]
topics <- extract_topics(artworks, xmlfiles = paste0(artworks, ".xml"),
                         xmlpath = "../data/haum/ContentEyevisit/eyevisit_cards_light/")

datlogs_topics <- add_topic(datlogs, topics = topics)


# export data
write.table(datlogs_topics, paste0("../data/haum/event_logfiles_", now, ".csv"),
            sep = ";", row.names = FALSE)

